{{
This is the start of a program to control a sprinkler system.

By Steven and computer_guy

}}
CON
  NumScheduleItems=100 'change this to whatever you want

  'pins that we are using for the clock
  inClk=4    'change these to whatever you are using
  inIO =5
  inCe =6

OBJ
  eeprom : "Propeller Eeprom"
  clock  : "DS1302"

VAR
  long schedule[NumScheduleItems]

'Format for schedule items is
'byte start hours
'byte start minutes
'byte run time
'byte control instruction
'Which comes to 1 long
  
PUB start
'to be done at some stage
  'Setup the clock
  clock.init(inClk,inIO,inCe)
  clock.config
  
'We need to check for serial input and check the time in here
'If either occures we need to call the appropiate function
'One of the methods from the serial will need to be setting the clocks


'These two methods are use to save and get the schedule from the eeprom
PUB getSchedule 'We probably won't actuall need this method but it was easy to write it so here it is
  eeprom.VarRestore(@schedule[0],@schedule[NumScheduleItems-1])

PUB backupSchedule
  eeprom.VarBackup(@schedule[0],@schedule[NumScheduleItems-1])

PUB insertItem(item)|i
'This adds a schedule item to the list
  repeat i from 0 to NumScheduleItems-1
    if schedule[i]==0
      schedule[i]:=item
      return

PUB newItem(hours,minutes,runTime,instruction)
  'This returns a long which is in the right format
  'and turns the hours and minutes into BCD

CON
  'some suggested codes - this is just an enumeration so that we don't have to rember a whole heap
  'of numbers
  start1
  stop1
  start2
  stop2
  
PUB doInstruction(instruction)
  'This will turn on/off whatever pin or do whatever else we want to do
  'Could even hoopup one of the timers so that we could get a PWM output
  case instruction
    start1:
      outa[1]~
    stop1:
      outa[1]~~
       